﻿/********************************************************************************/
/* 	gamecore.d																	*/
/*------------------------------------------------------------------------------*/
/*	製作		瓦千鳥（あるふぁ～秘密基地）									*/
/*	製作開始	2010/10/10														*/
/*	MAIL		dij@estate.ocn.ne.jp											*/
/*	URL			http://maglog.jp/alpha-secret-base/								*/
/*																				*/
/*	このソースは「やわらかライセンス」の元で配布されています。					*/
/*-更新履歴---------------------------------------------------------------------*/
/*	2010/10/10	D言語学習開始		2008/05/22	tamakoro 初版をベース			*/
/*	2010/11/01  ver1.00															*/
/*	なし																		*/
/*	なし																		*/
/*-その他-----------------------------------------------------------------------*/
/*	なし																		*/
/********************************************************************************/

private import state;
private import hell2;
private import boot;
private import actor;
private import vector;
private import keypad;
private import clickable;
//private import configparser;

import config;

//private import std.math;

/********************************************************************************/

//ConfigParser configparser = null;
const static string CONFIG_PATH = "config.ini";


/* GameMain *********************************************************************/
/*	ゲーム本体の状態															*/
/********************************************************************************/

class GameMain : GameState
{
public:
	//-----------------------------------------------------------------------------
	//システム制御用
	//-----------------------------------------------------------------------------
	enum SCENE{
		INIT = 0,
		START,
		MAIN,
		CLEAR,
		END,
		PAUSE,
		RELESE,
		
		//以下ゲーム内の演出
		PLAYER_WARP,
		ENEMY_GETWAIT,
		PLAYER_MISSWAIT,

		EXIT,
	};
	

	ConfigParser savedata;			// セーブデータ

	int timer;						// 汎用タイマー
	SCENE iSceneStatus;				// 画面の状態
	int stage;						// ステージ
	int stage_start_count;			// ステージ開始処理
	int stage_clear_count;			// ステージ開始処理
	int game_score = 0;				//スコア
	int game_combo = 0;				//スコア
	int combo_ani = 0;				//コンボアニメ
	int miss_ani = 0;				//ミスアニメ
	int hi_score = 0;				//ハイスコア
	int max_combo = 0;				//ハイスコア
	int ex_power = 0;				//エクストラゲージ
	int ex_mode = 0;				//エクストラゲージ
	int game_time_count = 0;		//ゲーム終了までの残り時間
	int menu_input = 0;				//敵を倒したときのWAITカウンタ

	int power = 0;					//パワーメータ
	int act = 0;					//攻撃アクションカウンタ
	int act_e = 0;					//攻撃アクションカウンタ
	int act_miss = 0;				//攻撃見送りカウンタ
	int drive = 0;					//進んだ距離
	int speed = 0;					//スピード

	struct UNIT {
	 int type;						//敵種類 0:無し 1:侍 2:槍 3:弓
	 int x;							//x座標
	 int y = 250;					//y座標
	 int hp;						//ライフ
	 int wait;						//待ち時間
	 int move;						//待ち時間
	 }
	UNIT player[5];
	UNIT enemy[5];

	struct KEY {
	int up;
	int down;
	int l;
	int r;
	int wait;
	}
	KEY pad; 
	int select;
	
	
	Keypad keypad;					// キーボード/ゲームパッド取得用
	//-----------------------------------------------------------------------------
	//ゲーム別に使用される特別処理用変数
	//-----------------------------------------------------------------------------

	//-----------------------------------------------------------------------------
	//	コンストラクタ
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	this()
	{
		setMsg( GameState.MSG_NONE );
		// 各種初期化
		timer = 0;

		savedata          = new ConfigParser();
		keypad = new Keypad();
		keypad.SetUseCancel( false );

		iSceneStatus = SCENE.INIT;

	}

	
	//-----------------------------------------------------------------------------
	//	シーンの初期化
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void init( )
	{
Hell_write( "Gamecoer init\n" );
		//リソースの読み込み

		//画像準備
		Hell_loadTexture("char","resource/image/char.bmp" , [0,255,0]);		
		Hell_loadTexture("menu","resource/image/menu.bmp" , [0,255,0]);

		Hell_loadTexture("map","resource/image/map.bmp" , [0,255,0]);		
		
		//効果音準備
		Hell_loadWAV("get",         "resource/sound/l1.wav");
		Hell_loadWAV("door",        "resource/sound/puwa.wav");				
		Hell_loadWAV("damage",        "resource/sound/damage.wav");
		Hell_loadWAV("select",        "resource/sound/select.wav");
		Hell_loadWAV("destroy",        "resource/sound/destroy2.wav");
		Hell_loadWAV("powerup",        "resource/sound/clear.wav");
		Hell_loadWAV("metal",        "resource/sound/metal.wav");

		//セーブデータ
		try
		{
			savedata.load(CONFIG_PATH);
		}
		catch(Exception e)
		{
			savedata.set("HI_SCORE",         0);
			savedata.set("MAX_COMBO",         0);
			savedata.set("HOSHI",         1);
			savedata.write();
		}
		hi_score = savedata.getint("HI_SCORE");
		max_combo = savedata.getint("MAX_COMBO");

		game_time_count = 3 * 60 * 60 ;	//ゲーム終了までの残り時間
		drive = 0;					//進んだ距離
		power = 0;					//進んだ距離

Hell_write( "Gamecoer init\n" );

		iSceneStatus = SCENE.START;

		//初期ステータス決定
		int j;

		for ( j = 1; j <= 3; j++ )
		{
			player[j].type = j ;				//味方種類 0:無し 1:侍 2:鎧 3:弓
			player[j].x = 64 * (4 - j) + 48;	//ｘ座標
			player[j].hp = 5;					//hp
		}

		for ( j = 1; j <= 3; j++ )
		{
			enemy[j].type = Hell_randInt(1, 4);	//敵種類 0:無し 1:侍 2:鎧 3:弓
			enemy[j].x = 64 * j + 280;			//ｘ座標
			enemy[j].hp = 5;					//hp
		}

	
	
	
	}
	


	//-----------------------------------------------------------------------------
	//	シーンの後処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void relese( )
	{
		iSceneStatus = SCENE.EXIT;
	}
	//-----------------------------------------------------------------------------
	//	開始演出
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneStart_move( )
	{
		int i;

		if ( stage_start_count < ( 60 * 3 ) )
		{
			stage_start_count++;
		}
		else 
		{
			Hell_playBgm( "resource/sound/bgm.ogg", -1, 0 );
			iSceneStatus = SCENE.MAIN;
			stage_start_count = 0;
		}
	}
	//-----------------------------------------------------------------------------
	//	ステージ開始表示処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneStart_draw( )
	{
		int i;
		
		if ( stage_start_count > ( 60 * 2 ) )
		{
			Hell_drawFont(" GO!! " , 240, 400 , 4 , 255,255,255);
		}
		else
		{
			Hell_drawFont("DEFENCE" , 220, 400 , 4 , 255,255,255);
		}
	}
	//-----------------------------------------------------------------------------
	//	クリア演出の処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneClear_move( )
	{
		if ( stage_clear_count > ( 60 * 2 ) )
		{
			if( keypad.isPushEnter(true) )
			{
				iSceneStatus = SCENE.RELESE;
			}
		}
		else 
		{
			stage_clear_count++;
		}
		
		
	}
	//-----------------------------------------------------------------------------
	//	クリア演出の表示
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneClear_draw( )
	{
		int min;
		int sec;
		int msec;
		char[] str;

		Hell_setAlpha(HELL_ALPHA_NORMAL);

//		Hell_drawFont( "RESULTS" , 200, 120 , 4 , 255,255,255);

		
		if ( hi_score <= game_score )
		{
			Hell_drawFont( "NEW RECORD !",170, 390 , 4 , 255,255,255);
		}

		if ( game_time_count > 0 )
		{
		Hell_drawFont("YOU LOSE" , 60, 250 , 8 , 100,100,255);
		}
		else
		{
		Hell_drawFont("YOU WIN!" , 60, 250 , 8 , 255,100,100);
		}

		if ( stage_clear_count > ( 60 * 2 ) )
		{
			Hell_drawFont("PRESS Z OR 1 BUTTON TO EXIT" , 100, 440 , 2 , 255,255,255);
		}
		else
		{
//			Hell_drawFont(" OWARI-!" , 200, 420 , 4 , 255,255,255);
		}
	}
	//-----------------------------------------------------------------------------
	//	ゲームオーバー演出
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneEnd( )
	{
//		iSceneStatus = SCENE.MAIN;
	}
	
	//-----------------------------------------------------------------------------
	//	オブジェクトの動作
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void move()
	{
		
		switch( iSceneStatus )
		{
		case SCENE.INIT:
			//初期化
			init( );
			break;
		case SCENE.START:
			//開始
			SeneStart_move( );
			break;
		case SCENE.MAIN:
			keypad.update( );	//リプレイキー入力の更新
			//メイン
			system_move( );

			break;
		case SCENE.CLEAR:
			//クリア
//			effect_move( );
//			mob_move( );
			SeneClear_move( );
			break;
		case SCENE.END:
			//ゲームオーバー
			break;
		case SCENE.PAUSE:
			//一時停止
			pause_move( );
			break;
		case SCENE.RELESE:
			//後処理
			relese( );
			break;

		case SCENE.EXIT:
		default:
			//シーンの終了
			setMsg(GameState.MSG_REQ_TITLE);
			break;
		}
	}
	
	//-----------------------------------------------------------------------------
	//	オブジェクトの描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void draw()
	{
		// 作画開始
		Hell_begin();
		resetPerspective();
		Hell_setAlpha(HELL_ALPHA_NORMAL);
		
		switch( iSceneStatus )
		{
		case SCENE.INIT:
			//初期化
			break;
		case SCENE.START:
			//開始
			system_draw( );

			SeneStart_draw( );
			break;
		case SCENE.MAIN:
			//メイン
			system_draw( );
			break;
		case SCENE.CLEAR:
			//クリア
			system_draw( );
			SeneClear_draw( );
			break;
		case SCENE.END:
			//ゲームーバー
			system_draw( );
			SeneEnd( );
			break;
		case SCENE.PAUSE:
			//一時停止
			system_draw( );
			pause_draw( );
			break;
		case SCENE.RELESE:
			//後処理
			break;
			
			
		case SCENE.EXIT:
		default:
			break;
		}
// for debug code start
//Hell_drawFPS( 550, 10 );
//Hell_drawFont( std.string.toString( cast( int )scroll_status ), 10, 10 * 1, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )position.y ), 10, 10 * 2, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )place ), 10, 10 * 3, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )motion ), 10, 10 * 4, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )debug_disp[0] ), 10, 10 * 5, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )jump_fream_count ), 10, 10 * 6, 1 , 255,255,255 );
// for debug code end

	}
	
	// 画面サイズ取得
	int getScreenWidth(){return boot.g_width;}
	int getScreenHeight(){return boot.g_height;}
	
	string zfill(string str , int n)
	{
		for(int t=str.length;t<n;t++){
			str = "0" ~ str;
		}
		return str;
	}
	
	//-----------------------------------------------------------------------------
	//	ゲーム情報、システムの処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void system_move( )
	{
		int i;
		int j;
		
		char[] str;
		//残り時間のカウント
		game_time_count--;

		//boostカウント
		ex_power = ex_power - 1;
		if (ex_power <0)
		{
		ex_power = 0;
		ex_mode = 0;
		}

		//攻撃エフェクトのカウント
		act = act - 4;
		if (act <= 0)
		{
		act = 0;
		}
		act_e = act_e - 4;
		if (act_e <= 0)
		{
		act_e = 0;
		}

		
		if ( pad.wait > 0 )	//コマンド入力待ちロック
		{
			pad.wait --;
			if (pad.wait == 0) 
			{ 
				player[1].move = 0;
				player[2].move = 0;
				player[3].move = 0;
				enemy[1].move = 0;
				enemy[2].move = 0;
				enemy[3].move = 0;

//				Hell_playWAV( "get", 0, -1 ); 
			
			}
		}
		
/*		if (keypad.isPressUp())			//コマンド↑
		{
		 	if ( pad.up == 0 )
		 	{
		 	Hell_playWAV( "select", 0, -1 );
		 	select --;
		 	pad.up = 1;
		 	}
		} 
		else
		{
			pad.up = 0;
		}

		if (keypad.isPressDown())		//コマンド↓
		{
		 	if ( pad.down == 0 )
		 	{
		 	Hell_playWAV( "select", 0, -1 );
		 	select ++;
		 	pad.down = 1;
		 	}
		} 
		else
		{
			pad.down = 0;
		}
		select = ( select + 2 ) % 2;	//セレクトループ化 0:戦闘Battle 1:後退Retreat
*/

		if (game_time_count == 0 )	//3分タイマー制限
		{
		select = 5;
		}

		if ( ( ((keypad.isPushEnter()) && (select == 0))  
			&& ( pad.wait == 0 ) ) || ( act_miss == 3 ) )	//コマンド決定 戦闘
		{
			pad.wait = 4 ;
			if ( power > 200 )
			{
			Hell_playWAV( "metal", 0, -1 );
			enemy[1].hp = enemy[1].hp - 5;							//攻撃ダメージ 一撃
			game_combo++;											//コンボ
			combo_ani = 30;											//コンボカウンタアニメ
			act = 64;												//攻撃エフェクト
				if ( max_combo < game_combo )
			{
				max_combo = game_combo;
				savedata.set("MAX_COMBO",   cast(int)max_combo);
				savedata.write();
			}
			}
			if ( ( power <= 200 ) && ( power > 100 ) )
			{
			Hell_playWAV( "damage", 0, -1 );
			enemy[1].hp = enemy[1].hp - 1;							//攻撃ダメージ 固定
			player[1].hp = player[1].hp - 1;						//味方ダメージ 固定
			game_combo = 0;
			act = 64;												//攻撃エフェクト
			act_e = 64;												//攻撃エフェクト
			}
			if ( power <= 100 )
			{
			Hell_playWAV( "damage", 0, -1 );
//			player[1].hp = player[1].hp - (250 - power) / 50;		//味方ダメージ
			player[1].hp = player[1].hp - 2;						//味方ダメージ 固定
			game_combo = 0;
			act_e = 64;												//攻撃エフェクト
			}
			
			if (( player[1].hp <=0 ) && ( player[2].hp <=0 ))
			{
				select = 5 ;			//終了キー
			}
			
			power = 0;												//ゲージリセット
			act_miss = 0;											//見送りカウンタ
		}
		
		if(((((keypad.isPushEnter()) && (select == 1)) || (keypad.isPushCancel()) ) 
			&& ( pad.wait == 0 ))	//コマンド決定 後退 + 死亡
			|| (player[1].hp <= 0 ))
		{
			Hell_playWAV( "door", 0, -1 );
			pad.wait = 4 ;
			power = 0;												//ゲージリセット
			act_miss = 0;											//見送りカウンタ

			if (player[1].hp <= 0 )
			{
				miss_ani = 30 ;
			}
			
			j = 0 + (player[1].hp <= 0 );
			for( i = 1; i <= 4; i++)
			{
				if (player[i].hp > 0)
				{
					j++;
				}
			}

				if ( j == 1 )
				{
				pad.wait = 0;
				}
				if ( j == 2 )
				{
				player[1].move =  1;
				player[2].move = -1;
				}
				if ( j == 3 )
				{
				player[1].move =  1;
				player[2].move =  1;
				player[3].move = -2;
				}
				if ( j == 4 )
				{
				player[1].move =  1;
				player[2].move =  1;
				player[3].move =  1;
				player[4].move = -3;
				}

			for( i = 1; i <= 4; i++)
			{
				player[i-1].type = player[i].type;
				player[i-1].y = player[i].y;
				player[i-1].hp = player[i].hp;

				player[i].x = 64 * (4 - i - player[i].move) + 48;
			}
			player[j].type = player[0].type;
			player[j].y = player[0].y;
			player[j].hp = player[0].hp;

		}

		if(game_time_count % 1800 == 1799 )	//味方増援
		{
			j = 0 ;
			for( i = 1; i <= 4; i++)
			{
				if (player[i].hp > 0)
				{
					j++;
				}
			}

				if ( j < 3 )
				{
				Hell_playWAV( "powerup", 0, -1 );
				pad.wait = 4 ;
				player[j+1].move =  1;
//				player[j+1].type = Hell_randInt(1, 4);			//増援をランダムで処理
				player[j+1].type = ( player[1].type ) % 3 + 1 ;	//増援が被らないように処理
				player[j+1].y = 250;
				player[j+1].hp = 5;
				player[j+1].x = 64 * (3 - j - player[j+1].move) + 50;
				}


		}
			
		if ((enemy[1].hp <= 0 ) && (pad.wait == 0))	//敵を倒した場合
		{
//			Hell_playWAV( "metal", 0, -1 );
			pad.wait = 4 ;
			game_score = game_score +game_combo * 10 ;
			j = 3;

				enemy[1].move = -1;
				enemy[2].move = -1;
				enemy[3].move = -1;

			for( i = 1; i <= 3; i++)
			{
				enemy[i-1].type = enemy[i].type;
				enemy[i-1].y = enemy[i].y;
				enemy[i-1].hp = enemy[i].hp;

				enemy[i].x = 64 * (i - enemy[i].move) + 280;
			}
			enemy[3].type = Hell_randInt(1, 4);
			enemy[3].y = 250;
			enemy[3].hp = 5;
			power = 0;
			if (ex_mode == 0)
			{
			ex_power = ex_power +75;
			}
			if (ex_power >= 300)
			{
			ex_power = 300;
			ex_mode = 1;
			}
		}
			
		for( i = 1; i <= 4; i++)		//キャラ移動
		{
			player[i].x =player[i].x + player[i].move*2 * 8;
			enemy[i].x =enemy[i].x + enemy[i].move*2 * 8;
		}

		if ( power > 200)
		{
			if (ex_mode == 1)
			{
				power = power + 1;					//攻撃ゲージ速度 BOOST
			}
			else if ( (player[1].type + 3 - enemy[1].type) % 3 == 0)
			{
				power = power + 5;					//攻撃ゲージ速度 同属性
			}
			else if ( (player[1].type + 3 - enemy[1].type) % 3 == 1)
			{
				power = power + 10;					//攻撃ゲージ速度 負け属性
			}
			else if ( (player[1].type + 3 - enemy[1].type) % 3 == 2)
			{
				power = power + 2;					//攻撃ゲージ速度 勝ち属性
			}
		}
		else if ( power > 100)
		{
			if (ex_mode == 1)
			{
				power = power + 30;					//攻撃ゲージ速度 BOOST
			}
			else if ( (player[1].type + 3 - enemy[1].type) % 3 == 0)
			{
				power = power + 3;					//攻撃ゲージ速度 同属性
			}
			else if ( (player[1].type + 3 - enemy[1].type) % 3 == 1)
			{
				power = power + 10;					//攻撃ゲージ速度 負け属性
			}
			else if ( (player[1].type + 3 - enemy[1].type) % 3 == 2)
			{
				power = power + 5;					//攻撃ゲージ速度 勝ち属性
			}
		}
		else 
		{
			if (ex_mode == 1)
			{
				power = power + 30;					//攻撃ゲージ速度 BOOST
			}
			else if ( (player[1].type + 3 - enemy[1].type) % 3 == 0)
			{
				power = power + 1;					//攻撃ゲージ速度 同属性
			}
			else if ( (player[1].type + 3 - enemy[1].type) % 3 == 1)
			{
				power = power + 10;					//攻撃ゲージ速度 負け属性
			}
			else if ( (player[1].type + 3 - enemy[1].type) % 3 == 2)
			{
				power = power + 5;					//攻撃ゲージ速度 勝ち属性
			}
		}

		if ( power > 300 )						//攻撃ゲージ初期化
		{
			power = 0;
			act_miss ++;						//見送りカウンタ 3回見送りでミス
		}

		
		if ( select == 5 )						//ゲーム終了
		{
			
			Hell_playBgm( "resource/sound/results.ogg", 1, 0 );

			//ハイスコアの保存
//			game_score = game_time_count;
			if ( hi_score < game_score )
			{
				keypad.save( "replay/replay_01.bin" );	//リプレイの保存
				hi_score = game_score;
				savedata.set("HI_SCORE",   cast(int)hi_score);
				savedata.write();
			}
			if ( max_combo < game_combo )
			{
				max_combo = game_combo;
				savedata.set("MAX_COMBO",   cast(int)max_combo);
				savedata.write();
			}

			iSceneStatus = SCENE.CLEAR;
		}
		
		if ( iSceneStatus == SCENE.MAIN )
		{
			if(keypad.isPushCancel(true))
			{
				//ポーズ
//				iSceneStatus = SCENE.PAUSE;
//				menu_input = 0;
			}
		}
	}
	//-----------------------------------------------------------------------------
	//	ゲーム情報、システムの描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void system_draw( )
	{
		int j;
		
		int min;
		int sec;
		int msec;
		char[] str;
		int r = 255;
		int g = 255;
		int b = 255;
		
		
		//背景
		Hell_drawTexture("map"				
			, 32
			, 32
			, 0
			, 400
			, 384, 240
			, 1.5 , 1.5
			, 0 
			,255, 255, 255, 255 );

		//バトルフィールド
//		Hell_drawRect(  220 - 2, 210 - 2, 196 + 4, 120 + 4, 0, 0, 255, 255, 255, 255);	//枠：
//		Hell_drawRect(  220, 210, 196, 120, 0, 0, 0, 0, 100, 255);						//枠抜き

//		power = 150 ;	//debug
		
		//新POWERゲージ 110401

		for ( j = 1; j <= 360 * cast( int )power / 600; j = j + 5 )
		{
			if ( j < 120 ) 
			{
			Hell_drawTexture("char"
				, player[1].x - 20
				, player[1].y - 30
				, 128
				, 0
				, 64, 64
				, 1.5 , 1.5
				, 3 - j
				,255, 255, 255, 255 );
			}
			else
			{
			Hell_drawTexture("char"
				, player[1].x - 20
				, player[1].y - 30
				, 192
				, 0
				, 64, 64
				, 1.5 , 1.5
				, 3 - j
				,255, 255, 255, 255 );
			}
		}
		
		//新BOOSTゲージ 110401

		for ( j = 1; j <= 360 * ex_power / 600; j = j + 5 )
		{
			Hell_drawTexture("char"
				, player[1].x - 20
				, player[1].y - 30
				, 0
				, 0
				, 64, 64
				, 1.5 , 1.5
				, 3 + j
				,255, 255, 255, 255 );
			if ( ( ex_mode == 1 ) && ( game_time_count % 3 == 0 ) )			//BOOST MODE表示
			{
			Hell_drawTexture("char"
				, player[1].x - 20
				, player[1].y - 30
				, 64
				, 0
				, 64, 64
				, 1.5 , 1.5
				, 3 + j
				,255, 255, 255, 255 );
			}
		}

//		Hell_drawFont( "PLAYER" , 130, 180 , 2 ,  66, 66,255);
//		Hell_drawFont( "ENEMY"  , 420, 180 , 2 , 255, 66, 66);
		Hell_drawFont( "POWER"  , player[1].x - 0, player[1].y - 40 , 1.5 , 255, 255 ,255);
		Hell_drawFont( "BOOST"  , player[1].x - 0, player[1].y + 65 , 1.5 , 255, 255 ,255);

		if ( ex_mode == 1 )			//BOOST MODE表示
		{
			if (game_time_count /3 % 3 == 0)
			{
				Hell_drawFont( "BOOST!" , 220, 322 , 4 , 255,0,0);
			}
			if (game_time_count /3 % 3 == 1)
			{
				Hell_drawFont( "BOOST!" , 222, 320 , 4 , 255,255,0);
			}
			if (game_time_count /3 % 3 == 2)
			{
				Hell_drawFont( "BOOST!" , 224, 322 , 4 , 0,255,0);
			}
		}
		
		
		//味方アニメーション
		if ((miss_ani /3 % 4 == 0) && (miss_ani >0 ))
		{
		Hell_drawTexture("char"				//味方 死亡
			, player[1].x - ( 30 - miss_ani)/3
			, player[0].y + ( 30 - miss_ani)*2
			, 15 * 32	//アニメーション
			, 7 * 32
			, 32, 32
			, 2.0 , 2.0
			, 0 
			,255, 255, 255, 255 );
		}
		if (miss_ani /3 % 4 > 0)
		{
		Hell_drawTexture("char"				//味方 死亡
			, player[1].x - ( 30 - miss_ani)/3
			, player[0].y + ( 30 - miss_ani)*2
			, ( player[0].type + 7 )* 32	//アニメーション
			, 7 * 32
			, 32, 32
			, 2.0 , 2.0
			, 0 
			,255, 255, 255, 255 );
		}

		if ( act > 0 )						//攻撃エフェクト
		{
			Hell_drawTexture("char"
				, player[1].x -8 + (96 - act)
				, player[1].y 
				, 32 * ( 7 + player[1].type ) 				//アニメーション
				, 32 * 8
				, 32, 32
				, 2.0 , 2.0
				, 360 - 45 
				,255, 255, 255, 255 );
		}
		
		for ( j = 1; j <= 4; j++ )
		{
			if ( player[j].hp > 0)
			{
			Hell_drawTexture("char"
				, player[j].x -8
				, player[j].y 
				, ( game_time_count % ( 8 * 6 ) + 0 ) / 6 * 32					//アニメーション
				, 32 * ( 1 + player[j].type )+ ((player[j].type + 3 - enemy[1].type) % 3)/2 *32*3
				, 32, 32
				, 2.0 , 2.0
				, 0 
				,255, 255, 255, 255 );

				Hell_drawRect( player[j].x - 2, player[j].y - 2 -10, 50 + 4, 10 + 4, 0, 0, 255, 255, 255, 255);	//hp枠：
				Hell_drawRect( player[j].x, player[j].y -10, 50, 10, 0, 0, 0, 0, 100, 255);						//hp枠抜き
				if ( player[j].hp > 0 )
				{
					Hell_drawRect( player[j].x, player[j].y -10, player[j].hp*10, 10, 0, 0,  255, 0, 0, 255);	//hp表示
				} 		

			}
		
		}
		
		//敵アニメーション
		if ((combo_ani /3 % 4 == 0) && (combo_ani >0 ))
		{
		Hell_drawTexture("char"				//敵 死亡
			, enemy[1].x + ( 30 - combo_ani)/3
			, enemy[0].y + ( 30 - combo_ani)*2
			, 15 * 32	//アニメーション
			, 6 * 32
			, 32, 32
			, 2.0 , 2.0
			, 0 
			,255, 255, 255, 255 );
		}
		if (combo_ani /3 % 4 > 0)
		{
		Hell_drawTexture("char"				//敵 死亡
			, enemy[1].x + ( 30 - combo_ani)/3
			, enemy[0].y + ( 30 - combo_ani)*2
			, ( enemy[0].type + 7 )* 32	//アニメーション
			, 6 * 32
			, 32, 32
			, 2.0 , 2.0
			, 0 
			,255, 255, 255, 255 );
		}

		if ( act_e > 0 )						//攻撃エフェクト
		{
			Hell_drawTexture("char"
				, enemy[1].x - ( 96 - act_e)
				, enemy[1].y 
				, 32 * ( 10 + enemy[1].type ) 				//アニメーション
				, 32 * 8
				, 32, 32
				, 2.0 , 2.0
				, 45 
				,255, 255, 255, 255 );
		}

		for ( j = 1; j <= 3; j++ )
		{
			if ( enemy[j].hp > 0)
			{
				if ( ex_mode == 0 )
				{
				Hell_drawTexture("char"
					, enemy[j].x 
					, enemy[j].y
					, ( game_time_count % ( 8 * 6 ) + 0 ) / 6 * 32	+ ( 32 * 8 )	//アニメーション
					, 32 * ( 1 + enemy[j].type )
					, 32, 32
					, 2.0 , 2.0
					, 0 
					,255, 255, 255, 255 );
				}
				else
				{
				Hell_drawTexture("char"
					, enemy[j].x 
					, enemy[j].y
					, ( game_time_count % ( 8 * 6 ) + 0 ) / 6 * 32	+ ( 32 * 8 )	//アニメーション
					, 32 * 5
					, 32, 32
					, 2.0 , 2.0
					, 0 
					,255, 255, 255, 255 );
				}

				Hell_drawRect( enemy[j].x - 2, enemy[j].y - 2 -10, 50 + 4, 10 + 4, 0, 0, 255, 255, 255, 255);	//hp枠：
				Hell_drawRect( enemy[j].x, enemy[j].y -10, 50, 10, 0, 0, 0, 0, 100, 255);						//hp枠抜き
				if ( enemy[j].hp > 0 )
				{
					Hell_drawRect( enemy[j].x, enemy[j].y -10, enemy[j].hp*10, 10, 0, 0,  255, 0, 0, 255);		//hp表示
				}
				
			}
		
		}
		

		/*
		Hell_drawRect(  170 - 2, 350 - 2, 300 + 4, 10 + 4, 0, 0, 255, 255, 255, 255);	//パワーゲージ枠：
		Hell_drawRect(  170, 350, 300, 10, 0, 0, 0, 0, 100, 255);						//パワーゲージ枠抜き
		Hell_drawRect(  170 - 2, 375 - 2, 300 + 4, 10 + 4, 0, 0, 255, 255, 255, 255);	//ex_パワーゲージ枠：
		Hell_drawRect(  170, 375, 300, 10, 0, 0, 0, 0, 100, 255);						//ex_パワーゲージ枠抜き
		Hell_drawFont( "POWER" , 100, 350 , 1.5 , 255, 255 ,255);
		Hell_drawFont( "BOOST" , 100, 375 , 1.5 , 255, 255 ,255);
		if ( ( power > 0 ) && ( power <=300) )
		{
			Hell_drawRect( 170, 350, cast( int )power , 10, 0, 0,  0, 255, 0, 255);		//パワーゲージ表示
			Hell_drawRect( 370, 350, 1, 10, 0, 0, 255, 255, 255, 255);					//パワーゲージ枠
		} 		
		if ( ( ex_power > 0 ) && ( ex_power <=300) && ( ex_mode == 0 ))
		{
			Hell_drawRect( 170, 375, ex_power , 10, 0, 0,  255, 255, 0, 255);			//ex_パワーゲージ表示 BOOST MODE
		} 		
		if ( ( ex_power > 0 ) && ( ex_power <=300) && ( ex_mode == 1 ))
		{
			Hell_drawRect( 170, 375, ex_power , 10, 0, 0, 255, 255 *(game_time_count /5 % 2), 255 *(game_time_count /5 % 2), 255);				//ex_パワーゲージ表示
		} 		
		if ( ( power > 200 ) && ( power <=300) )	//attack表示
		{
			if (game_time_count /3 % 3 == 0)
			{
				Hell_drawFont( "ATTACK" , 280, 282 , 1.5 , 255,0,0);
			}
			if (game_time_count /3 % 3 == 1)
			{
				Hell_drawFont( "ATTACK" , 282, 280 , 1.5 , 255,255,0);
			}
			if (game_time_count /3 % 3 == 2)
			{
				Hell_drawFont( "ATTACK" , 284, 282 , 1.5 , 0,255,0);
			}
		}
		if ( ex_mode == 1 )			//BOOST MODE表示
		{
			if (game_time_count /3 % 3 == 0)
			{
				Hell_drawFont( "BOOST!" , 220, 362 , 4 , 255,0,0);
			}
			if (game_time_count /3 % 3 == 1)
			{
				Hell_drawFont( "BOOST!" , 222, 360 , 4 , 255,255,0);
			}
			if (game_time_count /3 % 3 == 2)
			{
				Hell_drawFont( "BOOST!" , 224, 362 , 4 , 0,255,0);
			}
		}
*/

		
		if ( ( power > 200 ) && ( power <=300) )	//target表示
		{
			Hell_drawTexture("char"
				, 340 
				, 250
				, 32 * 8	//32 * (8 + (game_time_count /5 % 2) )	//アニメーション
				, 32 * 0
				, 32, 32
				, 2.0 , 2.0
				, game_time_count *5 % 360 
				,255, 255, 255, 255 );
		}

		
		min = ( game_time_count / 60 ) / 60;
		sec = ( game_time_count / 60 ) % 60;
		msec = game_time_count % 60;
		
		if ( iSceneStatus != SCENE.CLEAR )
		{
			//コマンド表示
//			Hell_drawFont( "ATTACK" , 100, 330 , 2 , 255,255,255);
//			Hell_drawFont( "RETREAT" , 100, 350 , 2 , 255,255,255);
//			Hell_drawFont( "[       ]" , 80, 330 +select*20 , 2 , 255,0,255);
			
			//debug表示//
			str = std.string.format( "%05d", select ); 
			str = std.string.format( "%05d", (player[0].type + 3 - enemy[0].type) % 3 ); 
			str = std.string.format( "%05d", ex_power ); 
//			Hell_drawFont( str , 410, 400 , 2 , r,g,b);
			
			str = std.string.format( "TIME %02d:%02d:%02d", min, sec, msec );
		
//			Hell_drawFont( "Z(1) ATTACK" , 50, 400 , 2 , 255,255,255);
//			Hell_drawFont( "X(2) CHANGE" , 50, 420 , 2 , 255,255,255);
//			Hell_drawFont( "30sec EXTEND" , 50, 445 , 2 , 255,255,255);
		
		}
		
		Hell_setAlpha(HELL_ALPHA_NORMAL);
		Hell_drawFont( str , 150, 370 , 3 , r,g,b);

		Hell_drawFont( "SCORE" , 80, 30 , 2 , 255,255,255);
		Hell_drawFont( std.string.toString( game_score ) , 90, 50 , 4 , 255,255,255);

//		Hell_drawFont( "COMBO"  , 80, 80 , 2 , 255, 255, 255);
//		Hell_drawFont( std.string.toString( game_combo ) , 110, 100 , 4 , 255,255,255);

		Hell_drawFont( "HI SCORE" , 400, 30 , 2 , 255,255,255);
		Hell_drawFont( std.string.toString( hi_score ) , 440, 50 , 4 , 255,255,255);
	
		Hell_drawFont( "MAX COMBO" , 400, 80 , 2 , 255,255,255);
		Hell_drawFont( std.string.toString( max_combo ) , 460, 100 , 4 , 255,255,255);
		
		Hell_drawFont( "COMBO"  , 270, 340 , 1.5 , 255, 255, 100);
		Hell_drawFont( std.string.toString( game_combo ) , 340, 340 , 1.5 , 255,255,100);

		if ( combo_ani > 0 )
		{
		Hell_drawFont( "COMBO" , enemy[1].x -10 , 210 + combo_ani , 2 , 255,255,100);
			if ( combo_ani >100 )
			{
			Hell_drawFont( std.string.toString( game_combo ) , enemy[1].x + 20 , 225 + combo_ani , 11.5   , 255,255,100);
			}
			else
			{
			Hell_drawFont( std.string.toString( game_combo ) , enemy[1].x + 20 , 225 + combo_ani , 1.5 + (game_combo) / 10 , 255,255,100);
			}
		combo_ani =combo_ani - 1;
		}
		if ( miss_ani > 0 )
		{
		Hell_drawFont( "DEAD" , player[1].x, 210 + miss_ani , 2 , 255, 33,33);
		miss_ani =miss_ani - 1;
		}
	}
	
	//-----------------------------------------------------------------------------
	//	ポーズの処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void pause_move( )
	{
		if(keypad.isPushUp(true))
		{
			Hell_playWAV( "select", 0, -1 );
			menu_input++;
			if ( menu_input > 1 )
			{
				menu_input = 0;
			}
		}
		else if(keypad.isPushDown(true))
		{
			Hell_playWAV( "select", 0, -1 );
			menu_input--;
			if ( menu_input < 0 )
			{
				menu_input = 1;
			}
		}
		if(keypad.isPushEnter(true))
		{
			switch ( menu_input )
			{
			case 0:
				//ポーズ解除
				iSceneStatus = SCENE.MAIN;
				break;
			case 1:
				//リトライ
				iSceneStatus = SCENE.RELESE;
				break;
			default:
				break;
			}
		}
		if(keypad.isPushCancel(true))
		{
			//ポーズ解除
			iSceneStatus = SCENE.MAIN;
		}
	}
	//-----------------------------------------------------------------------------
	//	ポーズの描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void pause_draw( )
	{
		Hell_setAlpha(HELL_ALPHA_NORMAL);
		Hell_drawTexture("menu"
			, 96 + 160
			, 64 + 120 + ( menu_input * 32 )
			, 320
			, 0
			, 32, 32
			, 1.0 , 1.0
			, 0
			,255, 255, 255, 255 );
		Hell_drawTexture("menu"
			, 160
			, 120
			, 0
			, 0
			, 320, 240
			, 1.0 , 1.0
			, 0
			,255, 255, 255, 255 );
	}
	
	
}


